
/*
 * @test TestBarrierDependencies
 * @run main/othervm -XX:ShenandoahGCHeuristics=aggressive -XX:+UseShenandoahGC -XX:-UseCompressedOops -XX:CompileOnly=TestBarrierDependencies.test TestBarrierDependencies
 */
public class TestBarrierDependencies {

    public static class Fluff {
	public Test test1;
	public Test test2;
    }

    public static class Test {
	public int x;
    }

    public static Fluff fluff;
    private static void setup() {
	Test obj = new Test();
	fluff = new Fluff();
	fluff.test1 = obj;
	fluff.test2 = obj;
    }
    public static void main(String[] args) {
	setup();
	for (int x = 0; x < 1000000; x++) {
	    int val = (int) (Math.random() * Integer.MAX_VALUE);
	    String garbage = new String("hello world");
	    test(fluff, val);
	}
    }

    private static void test(Fluff fluff, int value) {
	Test b = fluff.test2;
	if (b == null) throw new NullPointerException("b");
	Test a = fluff.test1;
	if (a == null) throw new NullPointerException("a");
	a.x = value;
	if (b.x != value) {
	    throw new RuntimeException("got wrong value");
	}
    }
}
